#ifndef CHECK_H
#define CHECK_H
#include "../goods/goods.h"

#include <vector>

typedef enum OperationTypes {
    funds_income, // Приход средств
    funds_return, // Возврат прихода
    funds_spend,  // Расход средств
    spends_return // Возврат расхода
} OperationType;

class Check {
    std::string fn; // Fiscal Number = Фискальный номер
    std::string fd; // Fiscal Document = Фискальный документ
    std::string fi; // Fiscal Identifier = Фискальный признак

    std::string date;
    OperationType operation_type;
    double total;

    std::vector<Goods> goods;

public:
    Check();
    Check(std::string date, double total, OperationType type, std::string fn, std::string fd, std::string fi, std::vector<Goods> goods);
    void add_goods(Goods);
    void add_goods(std::vector<Goods> &goods);

    double calculae_total_price();

    std::vector<Goods> &get_goods();

    void set_fn(std::string);
    void set_fd(std::string);
    void set_fi(std::string);
    void set_date(std::string);
    void set_operation_type(OperationType);
    void set_total(double);

    void set_goods(std::vector<Goods>);

    std::string get_fn();
    std::string get_fd();
    std::string get_fi();
    std::string get_date();
    OperationType get_operationType();
    double get_total();

    bool operator==(Check &);
    bool operator==(const Check &);
};


#endif // CHECK_H
