#ifndef GOODS_H
#define GOODS_H

#include <QDataStream>
#include <string>
#include <vector>

class Goods {
  std::string name;
  double quantity;        // by weight or by the piece
  std::string net_weight; // will contain values like "5мл" or "10г"
  double price_per_unit;

public:
  Goods();
  Goods(std::string name, double quantity, std::string net_weight,
        double price_per_unit);
  double calculate_total_price();

  std::string get_name();
  double get_quantity();
  std::string get_net_weight();
  double get_price_per_unit();

  void set_name(std::string);
  void set_name(QString);
  void set_quantity(double);
  void set_net_weight(std::string);
  void set_net_weight(QString);
  void set_price_per_unit(double);
};

QDataStream &operator<<(QDataStream &, Goods &);
QDataStream &operator>>(QDataStream &, Goods &);

QDataStream &operator<<(QDataStream &, std::vector<Goods> &);
QDataStream &operator>>(QDataStream &, std::vector<Goods> &);
#endif // GOODS_H
