#ifndef OUTPUT_OPTIONS_H
#define OUTPUT_OPTIONS_H

#include <string>
#include <vector>
#if __GNUC__ <= 8 && __clang_major__ < 17
#       include <experimental/filesystem>
#else
#       include <filesystem>
#endif
#include <iostream>
#include <string>
#include <vector>
#include "../net/net.h"
#include "../settings/settings.h"

enum ColumnType {
    date,
    goods_name,
    goods_price_per_unit,
    goods_quantity,
    goods_net_weight,
    goods_total
};

// Q_DECLARE_METATYPE(ColumnType);

// struct Column {         // Example:
//     ColumnType type;      // goods_name
//     std::string name;     // "Товар"
//     unsigned int position; // "0" <-- 0 = "A", 1 = "B", etc.. column letter in
//         // table processor (i.e. excel or libreoffice)
// } typedef Column;

class OutputOptions {
    bool print_header;
    bool print_total;
    std::string path;

public:
    OutputOptions();
    void remove_column(unsigned short);
    void remove_column(ColumnType);
    unsigned short find_column(ColumnType);
    bool column_exist(ColumnType);
    void set_print_header(bool);
    bool get_print_header();

    void set_print_total(bool);
    bool get_print_total();

    void set_path(std::string);
    std::string &get_path();
};

#endif // OUTPUT_OPTIONS_H


