#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include <QDialog>
#include <outputcolumn.h>
#include <settings/settings.h>

namespace Ui {
class settingsdialog;
}

class SettingsDialog : public QDialog {
    Q_OBJECT
    Settings settings;
    std::vector<OutputColumn> *columns;

public:
    explicit SettingsDialog(QWidget *parent = nullptr);
    ~SettingsDialog();

private slots:
    void on_printTotalCheckBox_stateChanged(int arg1);
    void on_printHeaderCheckBox_stateChanged(int arg1);

    void on_buttonBox_accepted();
    void on_buttonBox_rejected();

    void on_languageComboBox_currentTextChanged(const QString &arg1);

private:
    Ui::settingsdialog *ui;
public:
    bool settingsExist();
};

#endif // SETTINGSDIALOG_H
